    //-SLIDE 10-------------------------------------------------------------------
    //
    // Event Objects

    //
    // Create a manual reset event whose initial state is false and is unnamed
    //

    IoReadsDoneEvent = CreateEvent(NULL,TRUE,FALSE,NULL);

    //
    // One thread might signal that the event occured by setting the event
    //

    SetEvent(IoReadsDoneEvent);

    //
    // Another thread might wait for the event to occur by waiting on it
    //

    WaitForSingleObject(IoReadsDoneEvent,-1);

    //
    // Sometime you need to wait for more than one event to be set at the same time
    // use WaitForMultipleObjects in this scenario
    //
    // Wait for both events to be signaled at the same time (bWaitAll == TRUE)
    //

    CompletionHandles[0] = IoReadsDoneEvent;
    CompletionHandles[1] = IoWritesDoneEvent;
    WaitStatus = WaitForMultipleObjects(2,CompletionHandles,TRUE,0xffffffff);

    //
    // Use CloseHandle to release resources of the event
    //

    CloseHandle(IoReadsDoneEvent);

