    //-SLIDE 11--------------------------------------------------------------------
    //
    // Mutex Objects

    //
    // create an unnamed mutex that is NOT initially owned by the caller
    //

    Mutex = CreateMutex(NULL,FALSE,NULL);

    //
    // Aquire ownership of the mutex using wait
    //

    WaitStatus = WaitForSingleObject(Mutex,-1);

    if ( WaitStatus == WAIT_ABANDONED ) {

        //
        // I have ownership, but the last owner died while holding
        // this lock so attempt cleanup
        //

        cleanup();

        }

    //
    // When you are done in your single threaded region, use ReleaseMutex
    //

    ReleaseMutex(Mutex);

    //
    // Use CloseHandle to release resources of the mutex
    //

    CloseHandle(Mutex);



