    //-SLIDE 12--------------------------------------------------------------------
    //
    // Implementing a synchronized queue using a mutex and a semaphore

    //
    // Initialize a mutex and a semaphore
    //

    IoWorkerListLock = CreateMutex(NULL,FALSE,NULL);;
    IoWorkerListSemaphore = CreateSemaphore(NULL,0,0x7fffffff,NULL);
    InitializeListHead(&IoRequestList);

    //
    // To put an item on the list, grab the list mutex, insert your entry,
    // signal the semaphore, and release the mutex
    //

    WaitStatus = WaitForSingleObject(IoWorkerListLock,-1);
    InsertTailList(&IoRequestList,&paio->Links);
    ReleaseSemaphore(IoWorkerListSemaphore,1,NULL);
    ReleaseMutex(IoWorkerListLock);

    //
    // A thread can remove something from the list by waiting on the mutex
    // AND the semaphore. When both of these objects are signalled, the
    // thread has ownership of the list, and causes the semephore count
    // to decrement to account for the item being removed from the list
    //

    HandleVector[0] = IoWorkerListLock;
    HandleVector[1] = IoWorkerListSemaphore;

    WaitForMultipleObjects(
        2,
        HandleVector,
        TRUE,
        0xffffffff
        );

    //
    // thread has ownership of the list head, so remove an entry and
    // then release the list head lock
    //

    paio = (PAIO)RemoveHeadList(&IoRequestList);
    ReleaseMutex(IoWorkerListLock);

    //
    // Use CloseHandle to release resources of the semaphore
    //

    CloseHandle(IoWorkerListSemaphore);



