    //-SLIDE 14--------------------------------------------------------------------
    //
    // How to call SetProcessWorkingSetSize
    //

    //
    // To trim your working set (manual swap). VC++ does this in the GUI
    // in preperation for a windowless compile
    //

    SetProcessWorkingSetSize(GetCurrentProcess(),-1,-1);

    //
    // To set your minimum working set to 1mb and max to 4mb use
    // This is usefull if you use heavy cached I/O and have a predictable
    // internal memory load in your server. If you know your working set,
    // you can minimize paging in your app
    //

    SetProcessWorkingSetSize(GetCurrentProcess(),1048576,4194304);


    //-SLIDE 14--------------------------------------------------------------------
    //
    // How to call VirtualLock
    //
    // Lock 4096 bytes at location ReadWrite2
    //

    VirtualLock(ReadWrite2,4096);


    //-SLIDE 14--------------------------------------------------------------------
    //
    // How to use memory mapped files
    //

    //
    // To map a real file ( see global critical section example for named
    // shared memory example
    //
    //

    //
    // Open a handle to a file
    //

    FileHandle = CreateFile(
                    ImageName,
                    GENERIC_READ | GENERIC_WRITE,
                    FILE_SHARE_READ,
                    NULL,
                    OPEN_EXISTING,
                    0,
                    NULL
                    );

    //
    // Create a file mapping object for the entire file
    //

    MappingHandle = CreateFileMapping(
                        FileHandle,
                        NULL,
                        PAGE_READWRITE,
                        0,
                        0,
                        NULL
                        );
    //
    // Release our handle to the file
    //

    CloseHandle( FileHandle );


    //
    // Map the file into our address space
    //

    BaseAddress = MapViewOfFile(
                        MappingHandle,
                        FILE_MAP_READ | FILE_MAP_WRITE,
                        0,
                        0,
                        0
                        );
    //
    // Data in the file is now accessable using pointers based at BaseAddress
    //

    //
    // Release our handle to the mapping object
    //

    CloseHandle( MappingHandle );

    //
    // Unmap the file when you are done
    //

    UnmapViewOfFile( BaseAddress );

