BOOL WINAPI SnmpExtensionInit(  IN  DWORD   dwTimeZeroReference,
                                OUT HANDLE  *hPollForTrapEvent,
                                OUT View    *supportedView)
    {
    // Record the time reference provided by the Extendible Agent.
    dwTimeZero = dwTimeZeroReference;

    // Create an Event that will be used to communicate the occurence of traps
    // to the Extendible Agent.  The Extension Agent will assert this Event
    // when a trap has occured.  This is explained further later in this file.
    if ((*hPollForTrapEvent = CreateEvent(NULL, FALSE, FALSE, NULL)) == NULL)
    {
        // Indicate error?, be sure that NULL is returned to Extendible Agent.
    }

    // Indicate the MIB view supported by this Extension Agent, an object
    // identifier representing the sub root of the MIB that is supported.
    *supportedView = MIB_OidPrefix; // NOTE!  structure copy

    // Record the trap Event.  This example Extension Agent simulates traps by 
    // generating a trap after every given number of processed requests.
    hSimulateTrap = *hPollForTrapEvent;

    // Indicate that Extension Agent initialization was sucessfull.
    return TRUE;
    } // end SnmpExtensionInit()


BOOL SnmpExtensionInitEx( View *supportedView)
{
    BOOL retVal;

    retVal = TRUE;
    switch (whichView) {
        case 0:
            supportedView->idLength = 7;
            supportedView->ids = MyView2;
            break;
        case 1:
            supportedView->idLength = 7;
            supportedView->ids = MyView3;
            break;
        case 2:
            supportedView->idLength = 7;
            supportedView->ids = MyView4;
            break;
        default:
            retVal = FALSE;
            break;
    }
    whichView++;
    return(retVal);
}